//BilderLaden_505d.js
// 19.07.15 / Hans Haesler, Chtelard 52, CH-1018 Lausanne / hsa@ringier.ch
//DESCRIPTION:Vervielfltigt den ersten Druckbogen, importiert die Bilder des ausgewhlten Ordners. 

// vorbeugenderweise das Anzeigen von Dialogen aktivieren
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// testen, ob ein Dokument geffnet ist
if (app.documents.length == 0) {
	alert ("Es ist kein Dokument offen.", "Achtung");
	exit();
}

// aktuelles Dokument, Anzahl Druckbogen, Anzahl Seiten
var curDoc = app.documents[0];
var nSpr = curDoc.spreads.length;
if (nSpr > 1) {
	alert ("Das Dokument darf nur *einen* Druckbogen umfassen.", "Stop");
	exit();
}
var nPgs = curDoc.pages.length;

// die Bildrahmen zhlen
var imgFrames = new Array();
for (var p=0; p<nPgs; p++) {
	var allFrames = curDoc.pages[p].allPageItems;
	var nFra = allFrames.length;
	for (var i=0; i<nFra; i++) {
		if (allFrames[i].hasOwnProperty("graphics") == true) {
			if ((allFrames[i].contentType)*1 == 1735553140) { // = "GRAPHIC_TYPE"
				imgFrames.push(i);
			}
		}
	}
}
nImgFrames = imgFrames.length;

if (nImgFrames == 0) {
	alert ("Das Dokument enthlt keine Bildrahmen.", "Stop");
	exit();
}

// die Masseinheiten speichern
// wenn nicht 2053991795 (= Millimeter), auf Millimeter umstellen
vM = (curDoc.viewPreferences.verticalMeasurementUnits)*1;
hM = (curDoc.viewPreferences.horizontalMeasurementUnits)*1;
if (vM != 2053991795) {
	curDoc.viewPreferences.verticalMeasurementUnits = MeasurementUnits.millimeters;
}
if (hM != 2053991795) {
	curDoc.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.millimeters;
}

// den Bezugspunkt "links oben" auswhlen
trp = (app.layoutWindows[0].transformReferencePoint)*1;
if (trp != 1095660652) {
	app.layoutWindows[0].transformReferencePoint = 1095660652;
}

// 'sufString' ist eine globale Variable, enthlt eine Liste von Suffizes
sufString= "|.psd|.tif|.ai|.jpg|.pdf|.eps|.tiff|.png|.gif|";
// den Dialog zur Ordnerauswahl anzeigen 
var selFolder = Folder.selectDialog("Den Ordner whlen, welcher die zu importierenden Bilddateien enthlt");
// den Pfad zum Quellordner bestimmen
if (selFolder != null) {
	// vier Arrays vorbereiten
	var mainList = new Array();
	var foldList = new Array();
	var mainFileList = new Array();
	var subFileList  = new Array();
	var nMain = nSub = 0;

	// die Dateipfade im Hauptordner und die Unterordnerpfade holen
	var fileFold = getMainFiles(selFolder, mainList, foldList);
	
	mainFiles = fileFold[0];
	if (mainFiles.length > 0) {
		// zum Filtern schicken
		mainFileList = fileFilter1(mainFiles);
		nMain = mainFileList.length;
	}
	foldList  = fileFold[1];
	var nFold = foldList.length;
	if (nFold > 0) {
		var subsList = new Array();
		for (n=0; n<nFold; n++) {
			var tmpList = new Array();
			// die Dateipfade in den Unterordnern holen
			subsList = subsList.concat(getSubFiles(foldList[n], tmpList));
		}
		// zum Filtern schicken
		subFileList = fileFilter1(subsList);
		nSub = subFileList.length;
	}
	
	// die Anzahl Dateien (Total, Haupt- und Unterordner)
	var nAll = nMain + nSub;
	
	if (nAll == 0) {
		alert ("Der gewhlte Ordner enthlt keine Bilddateien, welche plaziert werden knnen.");
		exit();
	}
	
	// die Funktion aufrufen, welche die gespeicherten Vorgaben einliest
	var defStr = getPrefs();
	// die Werte ausziehen
	if (defStr != "") {
		var catDef = defStr.split("\n");
		fVal = catDef[0];
		if (fVal == "true") {
			fMan = true;
			fSub = false;
		}
		else {
			fMan = false;
			fSub = true;
		}
		pVal = catDef[1]*1;
		if (pVal == 0) {pVal = "";}
		hOff = catDef[2]*1;
		vOff = catDef[3]*1;
		aSor = catDef[4];
		if (aSor == "false") {aSor = false;}
		else {aSor = true;}
		bSor = catDef[5];
		if (bSor == "false") {bSor = false;}
		else {bSor = true;}
		cSor = catDef[6];
		if (cSor == "false") {cSor = false;}
		else {cSor = true;}
		dSor = catDef[7];
		if (dSor == "false") {dSor = false;}
		else {dSor = true;}
		eSor = catDef[8];
		if (eSor == "false") {eSor = false;}
		else {eSor = true;}
		nFit = catDef[9];
		if (nFit == "false") {nFit = false;}
		else {nFit = true;}
		iCnt = catDef[10];
		if (iCnt == "false") {iCnt = false;}
		else {iCnt = true;}
		fPrp = catDef[11];
		if (fPrp == "false") {fPrp = false;}
		else {fPrp = true;}
		sPct = catDef[12];
		if (sPct == "false") {sPct = false;}
		else {sPct = true;}
		fFra = catDef[13];
		if (fFra == "false") {fFra = false;}
		else {fFra = true;}
		nNam = catDef[14];
		if (nNam == "false") {nNam = false;}
		else {nNam = true;}
		fNam = catDef[15];
		if (fNam == "false") {fNam = false;}
		else {fNam = true;}
		pInf1 = catDef[16];
		if (pInf1 == "false") {pInf1 = false;}
		else {pInf1 = true;}
		pInf2 = catDef[17];
		if (pInf2 == "false") {pInf2 = false;}
		else {pInf2 = true;}
		vSpc = catDef[18]*1;
		tSiz = catDef[19]*1;
		jLft = catDef[20];
		if (jLft == "false") {jLft = false;}
		else {jLft = true;}
		jCnt = catDef[21];
		if (jCnt == "false") {jCnt = false;}
		else {jCnt = true;}
		jRgt = catDef[22];
		if (jRgt == "false") {jRgt = false;}
		else {jRgt = true;}
	}
	else {
		fMan = false;
		fSub = true;
		pVal = 80;
		hOff = 0;
		vOff = 0;
		aSor = true;
		bSor = false;
		cSor = false;
		dSor = true;
		eSor = false;
		nFit = true;
		iCnt = false;
		fPrp = false;
		sPct = false;
		fFra = false;
		nNam = true;
		fNam = false;
		pInf1= false;
		pInf2= false;
		vSpc = 2;
		tSiz = 10;
		jLft = true;
		jCnt = false;
		jRgt = false;
	}
	// die Funktion aufrufen, welche den Dialog vorbereitet, anzeigt und auswertet
	askUser(nMain, nSub, nAll);
	
	// den Array der Bildpfade erstellen
	if (fMan == true) {
		if (nMain > 0) {
			tmpList = mainFileList;
		}
		else {
			alert ("Der Hauptordner selbst enthlt keine Bilddateien.", "Stop");
			reStore();
			exit();
		}
	}
	else {
		if (nMain > 0 && nSub > 0) {
			tmpList = mainFileList.concat(subFileList);
		}
		else if (nMain > 0 && nSub == 0) {
			tmpList = mainFileList;
		}
		else if (nMain == 0 && nSub > 0) {
			tmpList = subFileList;
		}
	}
	if (aSor) { // alphabetisch sortieren
		if (fMan == true) { // nur Hauptordner
			if (dSor) { // aufsteigend
				defList = tmpList.sort();
			}
			else if (eSor) { // absteigend
				defList = tmpList.sort();
				defList.reverse();
			}
		}
		else { // auch Unterordner
			var namesArr = getNames(tmpList);
			// den Array sortieren
			namesArr.sort(function(a, b) {
				if (dSor) { // aufsteigend
					return a[1] > b[1];
				}
				else if (eSor) { // absteigend
					return a[1] < b[1];
				}
			});
			// dem definitiven Array zuweisen
			defList = namesArr;
		}
	}
	else if (bSor) { // numerisch sortieren
		// die Anzahl Namen
		var nNames = tmpList.length;
		// das Ziffern-RegExp-Objekt
		var num = new RegExp("[0-9]+");
		// prfen, ob der erste Name eine Ziffer enthlt
		var pos = tmpList[0].name.search(num);
		if (pos == -1) {
			alert ("Der erste Name enthlt keine Zahl.", "Stop");
			exit();
		}
		var numbersArr = getNumbers(tmpList, nNames, num);
		// den Array sortieren
		numbersArr.sort(function(a, b) {
			if (dSor) { // aufsteigend
				return a[1] - b[1];
			}
			else if (eSor) { // absteigend
				return b[1] - a[1];
			}
		});
		// dem definitiven Array zuweisen
		defList = numbersArr;
	}
	else if (cSor) { // Erstellungsdatum
		var datesArr = getDates(tmpList);
		// den Array sortieren
		datesArr.sort(function(a, b) {
			if (dSor) { // aufsteigend
				return a[1] - b[1];
			}
			else if (eSor) { // absteigend
				return b[1] - a[1];
			}
		});
		// dem definitiven Array zuweisen
		defList = datesArr;
	}
	
	// die Funktion aufrufen, welche die Bilder importier
	makeImageCatalog(defList);
	
	reStore();
	// die ursprngliche Ebene wieder aktivieren
	app.layoutWindows[0].activeLayer = actLayer;
	// die Ebenen wieder sperren (falls notwendig)
	for (var i=0; i<nLayers; i++) {
		if (lockLayers[i] == true) {
			curDoc.layers[i].locked = true;
		}
	}
	// das Ende der Aktion verknden
	var dlog = new Window("palette");
	dlog.size = [320,100];
	dlog.add("statictext", [80, 100, 320, 116], "Fertig.");
	dlog.show();
	$.sleep(999);
	dlog.close();
}


////////////////////////////// die Funktionen  ////////////////////////////////////////////////////

// die Funktion, welche die Dateien des Hauptordners auflistet (und die Unterordner)
function getMainFiles(selFolder, mainList, foldList) {
	var f = Folder(selFolder).getFiles();
	for(var i=0; i<f.length; i++) {
		if (f[i] instanceof Folder) {
			foldList.push(f[i]);
		}
		else {
			mainList.push(f[i]);
		}
	}
	return [mainList, foldList];
}

// die Funktion, welche die Dateien der Unterordner auflistet
function getSubFiles(subFolder, tmpList) {
	var f = Folder(subFolder).getFiles();
	for(var i=0; i<f.length; i++) {
		if (f[i] instanceof Folder) {
			getSubFiles(f[i], tmpList);
		}
		else {
			tmpList.push(f[i]);
		}
	}
	return tmpList;
}

// der erste Teil des Datei-Filters ///////////////////////////////////////////////////////////////
function fileFilter1(mainFiles){
	var curFileList = new Array();
	for (var i=0; i<mainFiles.length; i++) {
		curFile = mainFiles[i];
		if (fileFilter2(curFile)) {
			curFileList.push(curFile);
		}
	}
	return curFileList;
}

// der zweite Teil des Datei-Filters (Windows-Version)
function fileFilter2(curFile){
	var curName = curFile.name.toLowerCase();
	try {
		var curItems = curName.split(".");
		var curSuf = "|." + curItems[(curItems.length)-1] + "|";
		if (sufString.indexOf(curSuf) != -1) {
			return true;
		}
		else {
			return false;
		}
	}
	catch (e) {
		return false;
	}
	return false;
}

// die Funktion, welche die Informationen vorbereitet /////////////////////////////////////////////
function getPrefs() {
	var defStr = "";
	// die Datei lesen, welche die gespeicherten Werte enthlt
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/imagePrefs_505.txt");
	}
	else {
		var f = new File("~/Library/Preferences/imagePrefs_505.txt");
	}
	var fileIsOpen = f.open("r");
	if (fileIsOpen) {
		try {
			defStr = f.read();
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
	return defStr;
}

// die Funktion, welche den Dialog vorbereitet, anzeigt und auswertet /////////////////////////////
function askUser(nMain, nSub, nAll) {
	// Dialoge lschen, welche offen geblieben sind
	try {
		app.dialogs.everyItem().destroy();
	}
	catch (e) {
	}
	// den Dialog vorbereiten
	var labelWidth  = 135; 
	var textField   =  42;
	var textWidth1  =  64;
	var textWidth2  = 142;
	var aDialog = app.dialogs.add({name:"BilderLaden"});
	with (aDialog.dialogColumns.add()) {
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:" " + nAll, minWidth:labelWidth});
					staticTexts.add({staticLabel:" Dateien"});
					staticTexts.add({staticLabel:" "});
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"(Hauptordner = " + nMain + " / Unterordner = " + nSub + ")"});
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Ordnerwahl", minWidth:labelWidth});
					var folButtons = radiobuttonGroups.add();
					with (folButtons) {
						radiobuttonControls.add({staticLabel:"nur Hauptordner", checkedState:fMan, minWidth:textWidth2});
						radiobuttonControls.add({staticLabel:"auch Unterordner", checkedState:fSub});
					}
				}
			}
		}
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Bildgrsse:", minWidth:labelWidth});
					if (pVal == "") {
						var percentField = textEditboxes.add({editContents:"", minWidth:textField});
					}
					else {
						pVal = pVal*1;
						var percentField = realEditboxes.add({editValue:pVal, minWidth:textField});
					}
					staticTexts.add({staticLabel:"%  "});
					staticTexts.add({staticLabel:" ", minWidth:textWidth1});
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Horizontaler Versatz:", minWidth:labelWidth});
					var horizontalOffsetField = realEditboxes.add({editValue:hOff, minWidth:textField});
					staticTexts.add({staticLabel:"mm"});
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Vertikaler Versatz:", minWidth:labelWidth});
					var verticalOffsetField = realEditboxes.add({editValue:vOff, minWidth:textField});
					staticTexts.add({staticLabel:"mm"});
				}
			}
		}
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Sortierung", minWidth:labelWidth});
					var sorButtons = radiobuttonGroups.add();
					with (sorButtons) {
						radiobuttonControls.add({staticLabel:"alphabetisch", checkedState:aSor, minWidth:textWidth2});
						radiobuttonControls.add({staticLabel:"numerisch", checkedState:bSor});
						radiobuttonControls.add({staticLabel:"Erstellungsdatum", checkedState:cSor});
					}
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Richtung", minWidth:labelWidth});
					var dirButtons = radiobuttonGroups.add();
					with (dirButtons) {
						radiobuttonControls.add({staticLabel:"aufsteigend", checkedState:dSor});
						radiobuttonControls.add({staticLabel:"absteigend", checkedState:eSor});
					}
				}
			}
		}
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Bilder anpassen:", minWidth:labelWidth});
					var fitButtons = radiobuttonGroups.add();
					with (fitButtons) {
						radiobuttonControls.add({staticLabel:"Keine Anpassung", checkedState:nFit, minWidth:textWidth2});
						radiobuttonControls.add({staticLabel:"Zentrieren", checkedState:iCnt});
						radiobuttonControls.add({staticLabel:"Proportional", checkedState:fPrp});
						radiobuttonControls.add({staticLabel:"Kleinstmgliches %", checkedState:sPct});
						radiobuttonControls.add({staticLabel:"Rahmen an Inhalt", checkedState:fFra});
					}
				}
			}
		}
		with (borderPanels.add()) {
			with (dialogColumns.add()) {
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Bildlegende:", minWidth:labelWidth});
					var labelsButtons = radiobuttonGroups.add();
					with (labelsButtons) {
						radiobuttonControls.add({staticLabel:"Keine", checkedState:nNam, minWidth:textWidth2});
						radiobuttonControls.add({staticLabel:"Dateiname", checkedState:fNam});
					}
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Informationen:", minWidth:labelWidth});
					with (dialogColumns.add()) {
						var ppiInfo1 = checkboxControls.add({ staticLabel:"ppi (Original)", checkedState:pInf1});
						var ppiInfo2 = checkboxControls.add({ staticLabel:"ppi (effektiv)", checkedState:pInf2});
					}
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Vertikaler Abstand:", minWidth:labelWidth});
					var verticalSpace = realEditboxes.add({editValue:vSpc, minWidth:textField});
					staticTexts.add({staticLabel:"mm"});
					staticTexts.add({staticLabel:" "});
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Schriftgrad:", minWidth:labelWidth});
					var typeSize = realEditboxes.add({editValue:tSiz, minWidth:textField});
					staticTexts.add({staticLabel:"pt  "});
				}
				with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Ausrichtung:", minWidth:labelWidth});
					var justButtons = radiobuttonGroups.add();
					with (justButtons) {
						radiobuttonControls.add({staticLabel:"Links", checkedState:jLft});
						radiobuttonControls.add({staticLabel:"Zentriert", checkedState:jCnt});
						radiobuttonControls.add({staticLabel:"Rechts", checkedState:jRgt});
					}
				}
			}
		}
	}
	// den Dialog anzeigen und auswerten
	var dResult = aDialog.show();
	if (dResult == true) {
		var folType = folButtons.selectedButton;
		if (folType == 0) {
			fMan = true;
			fSub = false;
		}
		else {
			fMan = false;
			fSub = true;
		}
		try {
			var pValue = percentField.editValue;
		}
		catch (e) {
			var pValue = (percentField.editContents)*1;
		}
		pVal = pValue;
		var horizontalOffset = horizontalOffsetField.editValue;
		hOff = horizontalOffset;
		var verticalOffset = verticalOffsetField.editValue;
		vOff = verticalOffset;
		// die Sortierung
		var sortType = sorButtons.selectedButton;
		var soBtn = sortType;
		aSor = bSor = cSor = false;
		if (soBtn == 0) {
			aSor = true;
		}
		else if (soBtn == 1) {
			bSor = true;
		}
		else if (soBtn == 2) {
			cSor = true;
		}
		var dirType = dirButtons.selectedButton;
		var diBtn = dirType;
		dSor = eSor = false;
		if (diBtn == 0) {
			dSor = true;
		}
		else if (diBtn == 1) {
			eSor = true;
		}
		var fitType = fitButtons.selectedButton;
		var fBtn = fitType;
		if (fBtn == 0) {
			nFit = true;
			iCnt = false;
			fPrp = false;
			sPct = false;
			fFra = false;
		}
		else if (fBtn == 1) {
			nFit = false;
			iCnt = true;
			fPrp = false;
			sPct = false;
			fFra = false;
		}
		else if (fBtn == 2) {
			nFit = false;
			iCnt = false;
			fPrp = true;
			sPct = false;
			fFra = false;
		}
		else if (fBtn == 3) {
			nFit = false;
			iCnt = false;
			fPrp = false;
			sPct = true;
			fFra = false;
		}
		else if (fBtn == 4) {
			nFit = false;
			iCnt = false;
			fPrp = false;
			sPct = false;
			fFra = true;
		}
		selLabel = labelsButtons.selectedButton;
		var rBtn = selLabel;
		if (rBtn == 0) {
			nNam = true;
			fNam = false;
		}
		else if (rBtn == 1) {
			nNam = false;
			fNam = true;
		}
		pInf1 = ppiInfo1.checkedState;
		pInf2 = ppiInfo2.checkedState;
		vSpc  = verticalSpace.editValue;
		tSiz  = typeSize.editValue;
		var justType = justButtons.selectedButton;
		var jBtn = justType;
		if (jBtn == 0) {
			jLft = true;
			jCnt = false;
			jRgt = false;
			txtJust = Justification.leftAlign;
		}
		else if (jBtn == 1) {
			jLft = false;
			jCnt = true;
			jRgt = false;
			txtJust = Justification.centerAlign;
		}
		else if (jBtn == 2) {
			jLft = false;
			jCnt = false;
			jRgt = true;
			txtJust = Justification.rightAlign;
		}
		// die Einstellungen zu einer Textkette zusammensetzen
		var tmpList = new Array(fMan, pVal, hOff, vOff, aSor, bSor, cSor, dSor, eSor, nFit, iCnt, fPrp, sPct, fFra, nNam, fNam, pInf1, pInf2, vSpc, tSiz, jLft, jCnt, jRgt);
		var curDef = tmpList.join("\n");
		// die Funktion aufrufen, welche das Ergebnis in eine Datei schreibt
		writeResult(curDef);
	}
	else {
		aDialog.destroy();
		reStore();
		exit();
	}
	aDialog.destroy();
}

// die Namen feststellen
function getNames(tmpList) {
	namesArr = new Array();
	for (var n=0; n<tmpList.length; n++) {
		var curName = tmpList[n].name;
		namesArr.push([tmpList[n], curName]);
	}
	return namesArr;
}

// die Erzeugungsdaten feststellen
function getDates(tmpList) {
	// ein temporres Dokument und einen Bildrahmen erzeugen
	var tmpDoc = app.documents.add(false);
	var tmpFrm = tmpDoc.rectangles.add();
	datesArr = new Array();

	for (var n=0; n<tmpList.length; n++) {
		// das aktuelle Bild laden 
		var curImage = tmpList[n];
		tmpFrm.place(curImage);
		// das Datum feststellen
		try {
			var curTime = (tmpDoc.links[0].linkXmp.creationDate).getTime();
		}
		catch (e) {
			var curTime = (tmpList[n].created).getTime();
		}
		datesArr.push([tmpList[n], curTime]);
	}
	// das temporre Dokument schliessen
	tmpDoc.close(SaveOptions.no);
	return datesArr;
}

// die Zahlen ausziehen, einen neuen Array bilden
function getNumbers(tmpList, nNames, num) {
	numbersArr = new Array();
	for (var n=0; n<nNames; n++) {
		var numVal = tmpList[n].name.match(num);
		numbersArr.push([tmpList[n], numVal]);
	}
	return numbersArr;
}

// das Ergebnis in eine Datei schreiben ///////////////////////////////////////////////////////////
function writeResult(curDef) {
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/imagePrefs_505.txt");
	}
	else {
		var f = new File("~/Library/Preferences/imagePrefs_505.txt");
	}
	var fileIsOpen = f.open("w");
	if (fileIsOpen) {
		try {
			f.write(curDef);
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
}

// die Funktion, welche den Druckbogen dupliziert und die Bilder importiert ///////////////////////
function makeImageCatalog(defList) {
	var ctr = 0;
	var curPage, curFile, x1, y1, x2, y2, curRect, labelStyle, labelLayer;
	var nSpreads = (Math.ceil(nAll/nImgFrames));
	// den Druckbogen vervielfltigen
	for (var i=1; i<nSpreads; i++) {
		curDoc.spreads.item(-1).duplicate();
	}
	// die Seiten zhlen
	var nPages = curDoc.pages.length;
	// die Ebenen zhlen
	nLayers = curDoc.layers.length;
		// die aktive Ebene speichern
		actLayer = app.layoutWindows[0].activeLayer;
	if(selLabel > 0){
		// das Absatzformat "Bildlegende" erzeugen
		labelStyle = curDoc.paragraphStyles.item("Bildlegende");
		try {
			labelStyle.name;
		}
		catch (e) {
			labelStyle = curDoc.paragraphStyles.add({name:"Bildlegende"});
		}
		labelStyle.pointSize = tSiz;
		labelStyle.justification = txtJust;
		if (actLayer.name == "Bildlegenden") {
			actLayer = curDoc.layers[nLayers-1];
		}
		// die Ebene "Bildlegenden" erzeugen
		var labelLayer = curDoc.layers.item("Bildlegenden");
		try {
			labelLayer.remove();
		}
		catch (e){
		}
		try {
			labelLayer = curDoc.layers.add({name:"Bildlegenden"});
		}
		catch (e) {
		}
	}
	// die Ebenen entsperren (falls notwendig)
	lockLayers = new Array;
	for (var i=0; i<nLayers; i++) {
		locked = curDoc.layers[i].locked;
		lockLayers.push(locked);
		if (locked) {
			curDoc.layers[i].locked = false;
		}
	}
	var oldPc, newPc;
	for (var p=0; p<nPages; p++) {
		var curPage = curDoc.pages[p];
		var allFrames = curPage.allPageItems;
		var nFra = allFrames.length;
		for (var n=nFra-1; n>-1; n--) {
			if (allFrames[n].hasOwnProperty("graphics") == true) {
				if ((allFrames[n].contentType)*1 == 1735553140) { // = "GRAPHIC_TYPE"
					try {
						if (fSub == true || bSor == true || cSor == true) {
							curFile = defList[ctr][0];
						}
						else {
							curFile = defList[ctr];
						}
					}
					catch (e) {
						continue;
					}
					curRect = allFrames[n];
					try {
						curRect.place(File(curFile));
						ctr++;
						if (nFit == false) {
							if (pVal == "") {
								// die Anpassen-Optionen zuweisen
								if (iCnt) {
									curRect.fit(FitOptions.CENTER_CONTENT);
								}
								if (fPrp) {
									curRect.fit(FitOptions.PROPORTIONALLY);
									curRect.fit(FitOptions.CENTER_CONTENT);
								}
								if (sPct) {
									// den Inhalt des Rahmens proportional anpassen
									curRect.fit(FitOptions.FILL_PROPORTIONALLY);
									// die Bildgrsse feststellen
									oldPc = curRect.allGraphics[0].horizontalScale;
									// den Wert auf eine Nachkommastelle runden
									newPc = Math.floor((oldPc*10) + 0.5) / 10;
									// den neuen Werte zuweisen
									curRect.allGraphics[0].properties = {horizontalScale:newPc, verticalScale:newPc};
									// das Bild zentrieren
									curRect.fit(FitOptions.CENTER_CONTENT);
								}
							}
							else {
								curRect.allGraphics[0].properties = {horizontalScale:pVal, verticalScale:pVal};
								if (hOff !=0 || vOff !=0) {
									curRect.allGraphics[0].move(undefined,[hOff, vOff]);
								}
								if (iCnt) {
									curRect.fit(FitOptions.CENTER_CONTENT);
								}
							}
							if (fFra) {
								if (pVal == "") {
									curRect.fit(FitOptions.PROPORTIONALLY);
								}
								curRect.fit(FitOptions.FRAME_TO_CONTENT);
							}
						}
						// die Bildlegende einfgen, falls gewnscht
						if (selLabel == 1) {
							bH = tSiz/2;
							gB = curRect.geometricBounds;
							x1 = gB[1];
							y1 = gB[2]+vSpc;
							x2 = gB[3];
							y2 = y1+bH;
							actRes = -1;
							try {
								var actRes = curRect.allGraphics[0].actualPpi[0];
							}
							catch (e) {
							}
							effRes = -1;
							try {
								var effRes = curRect.allGraphics[0].effectivePpi[0];
							}
							catch (e) {
							}
							curPath = curFile.fsName.toString();
							pathItems = curPath.split("/");
							labelString = pathItems[(pathItems.length)-1];
							if (pInf1 && pInf2) {
								if (actRes != -1) {
									labelString = labelString + "\u0008Original: " + actRes + " ppi / effektiv: " + effRes + " ppi";
								}
							}
							else if (pInf1) {
								if (actRes != -1) {
									labelString = labelString + "\u0008Original: " + actRes + " ppi";
								}
							}
							else if (pInf2) {
								if (actRes != -1) {
									labelString = labelString + "\u0008effektiv: " + effRes + " ppi";
								}
							}
							captFrame = curPage.textFrames.add(labelLayer, undefined, undefined,{geometricBounds:[y1, x1, y2, x2], contents:labelString});
							captFrame.texts[0].appliedParagraphStyle = labelStyle;
							if (captFrame.parentStory.lines.length > 1) {
								captFrame.geometricBounds = [y1, x1, y2+bH, x2];
								app.findTextPreferences = app.changeTextPreferences = null;
								app.findTextPreferences.findWhat = "\u0008";
								if (!iCnt) {
									app.changeTextPreferences.changeTo = "\n\u0008";
								}
								else {
									app.changeTextPreferences.changeTo = "\n";
								}
								captFrame.parentStory.changeText();
								app.findTextPreferences = app.changeTextPreferences = null;
							}
						}
					}
					catch (e) {
					}
				}
			}
		}
	}
}

// Masseinheiten und Bezugspunkt zurcksetzen (falls notwendig) ///////////////////////////////////
function reStore() {
	if (vM != 2053991795) {
		curDoc.viewPreferences.verticalMeasurementUnits = vM;
	}
	if (hM != 2053991795) {
		curDoc.viewPreferences.horizontalMeasurementUnits = hM;
	}
	if (trp != 1095660652) {
		app.layoutWindows[0].transformReferencePoint = trp;
	}
}